/**
 * @file buttons.h
 * @author
 * @brief Button driver implementation
 * @version 0.2
 * @date 2023-05-26
 *
 * @copyright Copyright (c) 2023
 *
 */

#ifndef BUTTONS_H
#define BUTTONS_H

/* Includes --------------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <stdbool.h>

//
// Zephyr
//
#include <zephyr/kernel.h>
#include <zephyr/drivers/gpio.h>
#include <zephyr/pm/pm.h>

#include "app_common.h"

/* Global param ----------------------------------------------------------------------------------*/
typedef enum {
    BTN_STATE_RELEASED,
    BTN_STATE_PRESSED,
    BTN_STATE_DEBOUNCE,
    BTN_STATE_SINGLE_PRESS,
    BTN_STATE_DOUBLE_PRESS_WAIT,
    BTN_STATE_DOUBLE_PRESS,
    BTN_STATE_TRIPLE_PRESS_WAIT,
    BTN_STATE_TRIPLE_PRESS,
    BTN_STATE_LONG_PRESS
} button_state_t;

/* Global function prototypes  -------------------------------------------------------------------*/
void btn_timer_callback (struct k_timer *p_timer);
void btn_gpio_irq_callback (const struct device *dev, struct gpio_callback *cb, uint32_t pins);
void button_init (void);

#endif
